{-# LANGUAGE AllowAmbiguousTypes #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE PolyKinds #-}
module Copar.RefinementInterface
  ( RefinementInterface(..)
  , Label
  , Weight
  , F1
  , F3
  ) where

class (Ord (F1 f), Ord (F3 f)) => RefinementInterface f where
  init   :: F1 f -> [Label f] -> Weight f
  update :: [Label f] -> Weight f -> (Weight f, F3 f, Weight f)

type family Label  (f :: * -> *) :: *
type family Weight (f :: * -> *) :: *
type family F1     (f :: * -> *) :: *
type family F3     (f :: * -> *) :: *
