module TestHelpers (encoding) where

import           Data.MorphismEncoding (Encoding)
import qualified Data.MorphismEncoding as Encoding
import qualified Data.Vector as V

encoding :: [f1] -> [(Int, l, Int)] -> Encoding l f1
encoding f1 es = Encoding.new (V.fromList f1) (V.fromList (map toEdge es))
  where toEdge (from, lab, to) = Encoding.Edge from lab to
