module Copar.Coalgebra.Parser.Class
  ( MorphParser
  , ParseMorphism(..)
  ) where

import Data.Vector (Vector)

import Control.Monad.State.Strict (StateT)
import Copar.Coalgebra.Parser.Internal
import Copar.RefinementInterface
import Copar.Parser.Types

import Data.Text (Text,pack)

type MorphParser l f1 = StateT (ParserState l f1) Parser

class ParseMorphism f where
  parseMorphismPoint
    :: (Ord x)
    => f (MorphParser l f1 x)
    -> MorphParser l f1 (F1 f, Vector (x, Label f))
  printMorphismPoint :: f Text -> Text
  printMorphismPoint _ = pack "TODO"
