{-# LANGUAGE ConstraintKinds #-}
module Copar.Parser.Types
  ( Parser
  , ParserT
  , ParseErr
  , MonadParser
  ) where

import           Data.Void (Void)

import           Text.Megaparsec
import           Data.Text (Text)

type ParserT = ParsecT Void Text

type Parser = Parsec Void Text

type ParseErr = ParseErrorBundle Text Void

type MonadParser = MonadParsec Void Text
