module Copar.RewriteFunctors (applyFunctorRewrites) where

import           Copar.FunctorExpression.Type
import           Copar.FunctorExpression.Transform
import           Copar.Functors.SomeFunctor
import           Copar.Functors.AbsorbingPolynomial


applyFunctorRewrites
  :: FunctorExpression SomeFunctor a -> FunctorExpression SomeFunctor a
applyFunctorRewrites = absorbPolynomial


type Transformation a =
  FunctorExpression SomeFunctor a -> FunctorExpression SomeFunctor a


absorbPolynomial :: Transformation a
absorbPolynomial = transform (transformInner absorbInnerFunctors)
