-- | Wrapper module for prettyprinter.
--
-- This just reexportes commonly imported modules to cut down on the number of
-- import statements.
module Data.Text.Prettyprint
  ( module Data.Text.Prettyprint.Doc
  , module Data.Text.Prettyprint.Doc.Util
  , module Data.Text.Prettyprint.Doc.Render.Terminal
  ) where


import Data.Text.Prettyprint.Doc
import Data.Text.Prettyprint.Doc.Util
import Data.Text.Prettyprint.Doc.Render.Terminal
