module Data.List.UtilsSpec (spec) where

import Test.Hspec

import Data.List.Utils

spec :: Spec
spec = deleteLargestMSpec

deleteLargestMSpec :: Spec
deleteLargestMSpec = describe "deleteLargestM" $ do
  it "works for the empty list" $
    deleteLargestM @Int undefined [] `shouldBe` Just []

  it "works for a simple example" $
    deleteLargestM Just [1,3,5,2] `shouldBe` Just [1,3,2]

  it "only deletes one largest element" $
    deleteLargestM Just [1,5,3,5,2] `shouldBe` Just [1,3,5,2]
  
